<!DOCTYPE html>
{% block content %}
<html>
    <head>
        {% load django_simple_bulma %}
        {% bulma %}
        {% font_awesome %}
        
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <script src="https://use.fontawesome.com/releases/v5.15.4/js/all.js" data-auto-a11y="true" ></script>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <style>
            html{
                background-color: #f0efef;
            }

            .dropbtn {
            background-color: #04AA6D;
            color: white;
            padding: 16px;
            font-size: 16px;
            border: none;
            }

            .dropdown {
            position: relative;
            display: inline-block;
            }

            .dropdown-content {
            display: none;
            position: absolute;
            min-width: 160px;
            z-index: 1;
            }

            .dropdown-content a {
            padding: 6px 6px;
            text-decoration: none;
            display: block;
            }

            .dropdown-content a:hover {background-color: #ddd;}

            .dropdown:hover .dropdown-content {display: block;}

            .dropdown:hover .dropbtn {background-color: #3e8e41;}

            .switch {
            position: relative;
            display: inline-block;
            width: 60px;
            height: 34px;
            }

            .switch input { 
            opacity: 0;
            width: 0;
            height: 0;
            }

            .slider {
            position: absolute;
            cursor: pointer;
            top: 0;
            left: 0;
            right: 0;
            bottom: 0;
            background-color: #ccc;
            -webkit-transition: .4s;
            transition: .4s;
            }

            .slider:before {
            position: absolute;
            content: "";
            height: 26px;
            width: 26px;
            left: 4px;
            bottom: 4px;
            background-color: white;
            -webkit-transition: .4s;
            transition: .4s;
            }

            input:checked + .slider {
            background-color: #2b9e14;
            }

            input:focus + .slider {
            box-shadow: 0 0 1px #44f321;
            }

            input:checked + .slider:before {
            -webkit-transform: translateX(26px);
            -ms-transform: translateX(26px);
            transform: translateX(26px);
            }

            /* Rounded sliders */
            .slider.round {
            border-radius: 34px;
            }

            .slider.round:before {
            border-radius: 50%;
            }    
        </style>
            <script>
                jQuery(document).ready(function ($) {                   
                    function getCookie(name) {
                        let cookieValue = null;
                        if (document.cookie && document.cookie !== '') {
                            const cookies = document.cookie.split(';');
                            for (let i = 0; i < cookies.length; i++) {
                                const cookie = cookies[i].trim();
                                // Does this cookie string begin with the name we want?
                                if (cookie.substring(0, name.length + 1) === (name + '=')) {
                                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                                    break;
                                }
                            }
                        }
                        return cookieValue;
                    }
                    $('.a').on("click", function () {
                        if (!$("#modal").hasClass("is-active")) {
                            $("#modal").addClass("is-active")   
                            machine_name = $(this).attr("machine_name")
                            msg = "Voulez-vous vraiment supprimer " + machine_name +  " ?"
                            $("#msg").text(msg)

                            $("#delete").on("click", function(){
                                var url = window.location.href+ machine_name+"/";
                                var url_to_redirect = window.location.href;
                                $.ajax({
                                    headers: {
                                        "X-CSRFToken": getCookie("csrftoken") 
                                    },  
                                    url: url,
                                    type: 'POST',
                                    data:{"id_machine":machine_name},
                                    dataType:"json"
                                }); 
                                window.location.replace(url_to_redirect)   
                            })
                            
                        } 
                    });


                    $('.switch').on("change", function () {
                        console.log($(this).attr("valeur"))
                        if ($(this).attr("valeur") == "true") { 
                            bool = false
                        }
                        else if ($(this).attr("valeur") == "false"){
                            bool = true
                        }
                        
                        var machine_name = $(this).attr("machine_name");
                        var url = window.location.href+ machine_name+"/"+bool+"/";
                        var url_to_redirect = window.location.href;
                        $.ajax({
                            headers: {
                                "X-CSRFToken": getCookie("csrftoken") 
                            },  
                            url: url,
                            type: 'POST',
                            data:{"id_machine": machine_name, "value": bool},
                            dataType:"json"
                        }); 
                        setTimeout(function() {
                            window.location.replace(url_to_redirect)
                        }, 500)   
 
                    });

                    $("#close").on("click", function () {
                        if ($("#modal").hasClass("is-active")) {
                            $("#modal").removeClass("is-active")  
                        }  
                    });

                    $("#cancel").on("click", function () {
                        if ($("#modal").hasClass("is-active")) {
                            $("#modal").removeClass("is-active")  
                        }  
                    });

                    
                });

            </script>
    </head>
    <body>
        <div class="basic">
            {% include "navbar.html" %}
        </div>
            <div id="modal" class="modal">
            <div class="modal-background"></div>
            <div class="modal-card">
              <header class="modal-card-head">
                <p class="modal-card-title">Confirmation</p>
                <button id="close" class="delete" aria-label="close"></button>
              </header>
              <section class="modal-card-body">
                <p id="msg"></p>
              </section>
              <footer class="modal-card-foot">
                <button id="delete" class="button is-danger">Supprimer</button>
                <button id="cancel" class="button">Annuler</button>
              </footer>
            </div>
        </div>
            <section class="section">
                <div class="box">
                    <header class="box-header">
                        <div class="container is-fluid notification is-fullhd">
                            <div class="level">
                                <div class="level-left">
                                    <div class="level-item">
                                        <h1 class="title is-4">Liste des machines</h1>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </header>
                    <div class="box-content">
                        <div class="content">
                            <div class="level mb-1">
                                <div class='level-left is-grouped'>
                                    <div class="level-item">
                                        <div class="field">
                                            <br><a class="button is-link is-light" href="{% url 'create' %}">Nouvelle machine</a>
                                        </div>
                                    </div>
                                </div>
                                <div class='level-right is-grouped'>
                                    <div class="level-item">
                                        <div class="field">
                                          
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div>
                                <table class="table is-fullwidth is-hoverable ">
                                    <thead>
                                        <tr class="is-size-5">
                                            <th>Nom</th>
                                            <th>Adresse IP</th>
                                            <th>Description</th>
                                            <th>Supervision</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>                   
                                    <tbody>
                                        {% for key, value in datas.items %}
                                            <tr class="is-size-5">
                                                <td>{{key}}</td>
                                                <td>{{value.ip}}</td>
                                                <td>{{value.description}}</td>
                                                <td>                                              
                                                    {% if value.monitoring == True %}
                                                    <!-- <span class="tag is-success is-light is-medium"> Yes </span> -->
                                                    <label class="switch" machine_name="{{key}}" valeur="true">
                                                        <input class="check" type="checkbox" checked>
                                                        <span class="slider round"></span>
                                                    </label>
                                                    {%else%} 
                                                    <!-- <span class="tag is-danger is-light is-medium"> No </span> -->
                                                    <label class="switch" machine_name="{{key}}" valeur="false">
                                                        <input class="check" type="checkbox" >
                                                        <span class="slider round"></span>
                                                    </label>
                                                    {%endif%}
                                                </td>
                                                <td>
                                                    <div class="dropdown">
                                                        <span style="color:rgb(72, 95, 199)"><i class="fas fa-chart-bar"></i></span>
                                                        <div class="dropdown-content ">
                                                            <a href="{% url 'graph-debit' id_machine=key %}">Debit</a>
                                                            <a href="{% url 'graph-ram' id_machine=key %}">RAM usage</a>
                                                            <a href="{% url 'graph-cpu' id_machine=key %}">CPU usage</a>
                                                        </div>
                                                    </div>
                                                    <a href="{% url 'modify' id_machine=key %}"><i class="fas fa-edit"></i></a>
                                                    <a class="a" style="color:rgb(226, 17, 17)" machine_name="{{key}}"><i class="fas fa-trash"></i></a>
                                                    {# <span class="icon"><i class="fas fa-sort"></i></span> #}
                                                </td>
                                            </tr>   
                                        {%endfor%}
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <div class="box">
                    <header class="box-header">
                        <div class="container is-fluid notification is-fullhd">
                            <div class="level">
                                <div class="level-left">
                                    <div class="level-item">
                                        <h1 class="title is-4">Journalisation partielle</h1>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </header>
                    <div class="box-content">
                        <div class="content">
    
                            <table class="table is-fullwidth is-hoverable">
                                <thead>
                                    <tr class="is-size-5">
                                        <th>Nom</th>
                                        <th>Horodatage</th>
                                        <th>Message</th>
                                    </tr>
                                </thead>                   
                                <tbody>
                                    {% for key, value in datas_log.items %}
                                    <tr class="is-size-5">
                                        {% if forloop.counter <= 5 %}
                                        <td>{{value.machine}}</td></span>
                                        <td>{{value.time}}</td>
                                        <td><span class="tag is-danger is-light is-medium">{{value.message}}</span></td>
                                        {%endif%}
                                    {%endfor%}
                                
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
        </section>
    </body>
</html>
{% endblock content %}
